#!/bin/sh

INSTALL_DIR=/usr/local
MAN_DIR=/usr/local/man
DESKTOP=~/Desktop
VERSION=1.23.0

echo "Este script instala a Aplicao Carto de Cidado"
echo ""

uid=`id -u`

if [ $uid -eq 0 ]
then 
	echo "Leia com ateno o contrato de licena de utilizao presente no ficheiro Licenca_PT.rtf. Se decidir instalar e utilizar este programa, ter de concordar com os termos e condies do contrato de licena de uso. Aceita os termos do contrato? (Sim/No)"
	read acceptLicense
	if [ "$acceptLicense" = "sim" ] || [ "$acceptLicense" = "Sim" ] || [ "$acceptLicense" = "SIM" ]
	then

		echo "a copiar ficheiros..."
		test -d $INSTALL_DIR/lib/ || mkdir $INSTALL_DIR/lib
		install install/libpteidpkcs11.so.$VERSION $INSTALL_DIR/lib/libpteidpkcs11.so.$VERSION
		install install/libpteidlibopensc.so.$VERSION  $INSTALL_DIR/lib/libpteidlibopensc.so.$VERSION
		install install/libpteid.so.$VERSION $INSTALL_DIR/lib/libpteid.so.$VERSION
		install install/libpteiddlg.so.$VERSION $INSTALL_DIR/lib/libpteiddlg.so.$VERSION
		install install/libpteidhttps.so.$VERSION $INSTALL_DIR/lib/libpteidhttps.so.$VERSION
	
		ln -sf $INSTALL_DIR/lib/libpteidpkcs11.so.$VERSION $INSTALL_DIR/lib/libpteidpkcs11.so
		ln -sf $INSTALL_DIR/lib/libpteidlibopensc.so.$VERSION $INSTALL_DIR/lib/libpteidlibopensc.so
		ln -sf $INSTALL_DIR/lib/libpteid.so.$VERSION $INSTALL_DIR/lib/libpteid.so
		ln -sf $INSTALL_DIR/lib/libpteiddlg.so.$VERSION $INSTALL_DIR/lib/libpteiddlg.so
		ln -sf $INSTALL_DIR/lib/libpteidhttps.so.$VERSION $INSTALL_DIR/lib/libpteidhttps.so
	        echo "$INSTALL_DIR/lib" >> /etc/ld.so.conf
		/sbin/ldconfig

		test -d $INSTALL_DIR/bin || mkdir $INSTALL_DIR/bin
		install install/pteidgui $INSTALL_DIR/bin/pteidgui
		install install/pteidtrayapplet $INSTALL_DIR/bin/pteidtrayapplet
		install install/pteiddlgsrv $INSTALL_DIR/bin/pteiddlgsrv
	
		test -d $INSTALL_DIR/bin/imageformats || mkdir $INSTALL_DIR/bin/imageformats
		install install/libqtjp2.so $INSTALL_DIR/bin/imageformats/
	
		test -d $INSTALL_DIR/bin/translations || mkdir $INSTALL_DIR/bin/translations
	        install install/pcscerrors_pt.qm $INSTALL_DIR/bin/translations
	        install install/pteiddlg_pt.qm $INSTALL_DIR/bin/translations
		install install/pteidgui_pt.qm $INSTALL_DIR/bin/translations
		install install/pteidtrayapplet_pt.qm $INSTALL_DIR/bin/translations
	
		test -d $INSTALL_DIR/include/pteid || mkdir $INSTALL_DIR/include/pteid
	        install install/pteidlib.h $INSTALL_DIR/include/pteid/
	        install install/pteiddefines.h $INSTALL_DIR/include/pteid/
	
	        test -d $INSTALL_DIR/bin/images || mkdir $INSTALL_DIR/bin/images
	        install install/app.png $INSTALL_DIR/bin/images
	
	        test -d $INSTALL_DIR/lib/pteidpp || mkdir $INSTALL_DIR/lib/pteidpp
	        install install/libpteidpp1_gempc.so.$VERSION $INSTALL_DIR/lib/pteidpp
	        ln -sf $INSTALL_DIR/lib/pteidpp/libpteidpp1_gempc.so.$VERSION $INSTALL_DIR/lib/pteidpp/libpteidpp1_gempc.so
	
	        test -d $INSTALL_DIR/lib/pteid_jni || mkdir $INSTALL_DIR/lib/pteid_jni
	        install install/pteidlibj.jar $INSTALL_DIR/lib/pteid_jni/
	        install install/libpteidlibj.so.$VERSION $INSTALL_DIR/lib/pteid_jni/
	        install install/Test.java $INSTALL_DIR/lib/pteid_jni/
	        ln -sf $INSTALL_DIR/lib/pteid_jni/libpteidlibj.so.$VERSION $INSTALL_DIR/lib/pteid_jni/libpteidlibj.so
	
	        test -d $INSTALL_DIR/bin/eidstore || mkdir $INSTALL_DIR/bin/eidstore
	        test -d $INSTALL_DIR/bin/eidstore/certs || mkdir $INSTALL_DIR/bin/eidstore/certs
	        install install/*.der $INSTALL_DIR/bin/eidstore/certs
			
		install Desktop/Cartao\ de\ Cidadao.desktop $DESKTOP

	        echo ""
	        echo "Por favor consulte o ficheiro README para obter mais informaes"
	        echo "acerca das bibliotecas necessrias para executar a aplicao."
	        echo ""
	else
		echo "Instalao cancelada."
		exit 1
	fi
else
	echo " necessrio ter permisses de super-utilizador (root) para instalar a Aplicao Carto de Cidado."
	echo "Por favor contacte o administrador de sistema."
	echo ""
fi
