#pragma once
#include "../pteidlib/pteidlib.h"

using namespace System;

namespace eidpt 
{	
  	public enum class PteidCapPinChangeState 
	{
		INITIALISING	= CAP_INITIALISING,		// Initialising
		CONNECTING		= CAP_CONNECTING,		// Connecting to the Server (PIN is asked)
		READING_INFO	= CAP_READING_INFO,		// Reading info from the card
		SENDING_INFO	= CAP_SENDING_INFO,		// Sending info to the server
		WRITE			= CAP_WRITE,			// Change the PIN in the card
		FINISH			= CAP_FINISH,			// Finish the CAP PIN change(send responses to the server)
		FINISHED		= CAP_FINISHED,			// The CAP PIN Change flow has completed.
		CANCELLED		= CAP_CANCELLED			// The CAP PIN Change flow was cancelled.
	};

	// class mimicking PTEID_Pin
    public ref class PteidPin
    {
    public: 
        PteidPin(const PTEID_Pin& i);

        long    pinType;          
        Byte    id;      
        long    usageCode;  
        long    triesLeft; 
        long    flags; 
        String^ label; 
        String^ shortUsage;     // May be NULL for usage known by the middleware 
        String^ longUsage;      // May be NULL for usage known by the middleware 
    };
}