// stdafx.h : include file for standard system include files,
// or project specific include files that are used frequently,
// but are changed infrequently

#pragma once
#include <string>

// System::String -> std::string
std::string     StringManagedToUnmanaged(System::String^ managed);

// System::string -> char[]
void            StringManagedToUnmanaged(char* out, System::String^ in, unsigned int maxSize);

// const char* -> System::String
System::String^ StringUnmanagedToManaged(const char* unmanaged);

// System::Array<TypeSource> -> TypeDestination*
// The new length is returned. maxSize is to prevent buffer overflow, if the managed array size is smaller, only that part is copied
template<typename TypeDestination, typename TypeSource>
unsigned int ArrayManagedToUnmanaged(array<TypeSource>^ managed, TypeDestination* unmanaged, unsigned int maxSize)
{
    unsigned int i = 0;
    for(; maxSize > i && static_cast<unsigned int>(managed->Length) > i; ++i)
        unmanaged[i] = managed[i];
    return i;
}

// TypeSource* -> System::Array<TypeDestination>
template<typename TypeDestination, typename TypeSource>
array<TypeDestination>^ ArrayUnmanagedToManaged(TypeSource* unmanaged, unsigned int size, bool trim=false)
{
    array<TypeDestination>^ managed = gcnew array<TypeDestination>(size);
    for(unsigned int i = 0; size > i; ++i)
        managed[i] = unmanaged[i];

 	if(trim)
	{
		unsigned int upperbound = size;
		for(; upperbound > 0; --upperbound)
		{
			if(managed[upperbound-1]!=0)
				break;
		}

		if(upperbound != size)
			System::Array::Resize(managed,upperbound);
	}
   return managed;
}

// TypeSource* -> System::Array<TypeDestination>
template<typename TypeDestination, typename TypeSource>
void AssignArrayUnmanagedToManaged(array<TypeDestination>^% managed, TypeSource* unmanaged, unsigned int size, bool trim=false)
{
	if(managed->Length < size)
		System::Array::Resize(managed,size);

    for(unsigned int i = 0; i < size; ++i)
        managed[i] = unmanaged[i];

	if(trim)
	{
		unsigned int upperbound = size;
		for(; upperbound > 0; --upperbound)
		{
			if(managed[upperbound-1]!=0)
				break;
		}

		if(upperbound != size)
			System::Array::Resize(managed,upperbound);
	}
}